diff -ruN ccp4srs-old/ccp4srs/ccp4srs_smiles.cpp ccp4srs/ccp4srs/ccp4srs_smiles.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_smiles.cpp	1969-12-31 16:00:00.000000000 -0800
+++ ccp4srs/ccp4srs/ccp4srs_smiles.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -0,0 +1,370 @@
+//  $Id: ccp4srs_smiles.cpp $
+//  =================================================================
+//
+//   CCP4 SRS Library: Storage, Retrieval and Search support for
+//   CCP4 ligand data.
+//
+//   Copyright (C) Eugene Krissinel 2010-2013.
+//
+//   This library is free software: you can redistribute it and/or
+//   modify it under the terms of the GNU Lesser General Public
+//   License version 3, modified in accordance with the provisions
+//   of the license to address the requirements of UK law.
+//
+//   You should have received a copy of the modified GNU Lesser
+//   General Public License along with this library. If not, copies
+//   may be downloaded from http://www.ccp4.ac.uk/ccp4license.php
+//
+//   This program is distributed in the hope that it will be useful,
+//   but WITHOUT ANY WARRANTY; without even the implied warranty of
+//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//   GNU Lesser General Public License for more details.
+//
+//  =================================================================
+//
+//    12.04.14   <--  Date of Last Modification.
+//                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+//  -----------------------------------------------------------------
+//
+//  **** Module  :  ccp4srs_smiles  <implementation>
+//       ~~~~~~~~~
+//  **** Classes :  ccp4srs::Smiles  - atom description class
+//       ~~~~~~~~~
+//
+//  (C) E. Krissinel 2010-2014
+//
+//  =================================================================
+//
+
+#include <string.h>
+
+#include "ccp4srs_smiles.h"
+#include "ccp4srs_defs.h"
+
+namespace ccp4srs  {
+
+  Smiles::Smiles()  {
+    ver       = NULL; //!< software version
+    plain     = NULL; //!< plain smiles
+    canonical = NULL; //!< canonical smiles
+  }
+
+  Smiles::~Smiles()  {
+    freeSmiles();
+  }
+
+  void Smiles::freeSmiles()  {
+    if (ver)       delete[] ver;
+    if (plain)     delete[] plain;
+    if (canonical) delete[] canonical;
+    ver       = NULL; //!< software version
+    plain     = NULL; //!< plain smiles
+    canonical = NULL; //!< canonical smiles
+  }
+
+  void Smiles::write_mem ( PMemIO memIO, int version )  {
+  UNUSED_ARGUMENT(version);
+    memIO->put_string ( ver       );
+    memIO->put_string ( plain     );
+    memIO->put_string ( canonical );
+  }
+
+  bool Smiles::read_mem ( PMemIO memIO, int version, bool * Ok )  {
+  UNUSED_ARGUMENT(version);
+  bool success;
+    if (Ok)  success = *Ok;
+       else  success = true;
+    if (version>=3)  {
+      memIO->get_string ( ver      ,&success );
+      memIO->get_string ( plain    ,&success );
+      memIO->get_string ( canonical,&success );
+    } else
+      freeSmiles();
+    if (Ok)  *Ok = success;
+    return success;
+  }
+
+  int Smiles::readFromCIF_rcsb ( mmdb::mmcif::PLoop mmCIFLoop,
+                                 mmdb::cpstr  program )  {
+  mmdb::pstr p;
+  int        i,loop_len,rc;
+
+    rc = 0;
+    loop_len = mmCIFLoop->GetLoopLength();
+    for (i=0;(i<loop_len) && (!rc);i++)  {
+      p = mmCIFLoop->GetString ( MMCIF_TAG_PROGRAM,i,rc );
+      if (p)  {
+        if (!strcmp(p,program))  {
+          mmdb::CreateCopy( ver,
+                mmCIFLoop->GetString(MMCIF_TAG_PROGRAM_VERSION,i,rc) );
+          p = mmCIFLoop->GetString ( MMCIF_TAG_TYPE,i,rc );
+          if (p)  {
+            if ((!strcmp(p,"SMILES")) || (!strcmp(p,"InChI")))
+                  mmdb::CreateCopy( plain,
+                     mmCIFLoop->GetString(MMCIF_TAG_DESCRIPTOR,i,rc) );
+            else  mmdb::CreateCopy( canonical,
+                     mmCIFLoop->GetString(MMCIF_TAG_DESCRIPTOR,i,rc) );
+          }
+        }
+      }
+    }
+
+    return rc;
+
+  }
+
+  void Smiles::copy ( PSmiles smiles )  {
+    mmdb::CreateCopy ( ver      ,smiles->getVersion  () );
+    mmdb::CreateCopy ( plain    ,smiles->getSmiles   () );
+    mmdb::CreateCopy ( canonical,smiles->getCanonical() );
+  }
+
+  bool Smiles::isEmpty()  {
+    return ((!ver) && (!plain) && (!canonical));
+  }
+
+/*
+  void  get_bond_type_from_cif_ccp4 ( int & type, mmdb::mmcif::PLoop loop,
+                                      mmdb::cpstr Tag, int row, int & rc )  {
+  mmdb::pstr p;
+     p = loop->GetString ( Tag,row,rc );
+     if (!p)                         type = Smiles::noOrder;
+     else if (!strcmp(p,"single"))   type = Smiles::Single;
+     else if (!strcmp(p,"aromatic")) type = Smiles::Aromatic;
+     else if (!strcmp(p,"aromat"))   type = Smiles::Aromatic;
+     else if (!strcmp(p,"double"))   type = Smiles::Double;
+     else if (!strcmp(p,"triple"))   type = Smiles::Triple;
+     else if (!strcmp(p,"deloc"))    type = Smiles::Deloc;
+     else if (!strcmp(p,"coval"))    type = Smiles::Covalent;
+     else if (!strcmp(p,"metal"))    type = Smiles::Metal;
+     else  {
+       type = Smiles::noOrder;
+       rc   = CCP4SRS_WrongBondType;
+     }
+  }
+
+  void  get_bond_type_from_cif_rcsb ( int & type,
+                                      mmdb::mmcif::PLoop loop,
+                                      mmdb::cpstr Tag,
+                                      int row, int & rc )  {
+  mmdb::pstr p;
+     p = loop->GetString ( Tag,row,rc );
+     if (!p)                       type = Smiles::noOrder;
+     else if (!strcmp(p,"SING"))   type = Smiles::Single;
+     else if (!strcmp(p,"AROM"))   type = Smiles::Aromatic;
+     else if (!strcmp(p,"DOUB"))   type = Smiles::Double;
+     else if (!strcmp(p,"TRIP"))   type = Smiles::Triple;
+     else  {
+       type = Smiles::noOrder;
+       rc   = CCP4SRS_WrongBondType;
+     }
+  }
+
+  void  get_bond_type_from_cif ( int & type,
+                                 mmdb::mmcif::PStruct mmCIFStruct,
+                                 mmdb::cpstr Tag, int & rc )  {
+  mmdb::pstr p;
+     p = mmCIFStruct->GetString ( Tag,rc );
+     if (!p)                       type = Smiles::noOrder;
+     else if (!strcmp(p,"SING"))   type = Smiles::Single;
+     else if (!strcmp(p,"AROM"))   type = Smiles::Aromatic;
+     else if (!strcmp(p,"DOUB"))   type = Smiles::Double;
+     else if (!strcmp(p,"TRIP"))   type = Smiles::Triple;
+     else  {
+       type = Smiles::noOrder;
+       rc   = CCP4SRS_WrongBondType;
+     }
+  }
+
+  void add_bond_type_to_cif ( mmdb::mmcif::PLoop loop, int type )  {
+    switch (type)  {
+      default:
+      case Smiles::noOrder:  loop->AddNoData ( mmdb::mmcif::CIF_NODATA_DOT );
+                                break;
+      case Smiles::Single:   loop->AddString ( "single"  ,false );
+                                break;
+      case Smiles::Aromatic: loop->AddString ( "aromatic",false );
+                                break;
+      case Smiles::Double:   loop->AddString ( "double"  ,false );
+                                break;
+      case Smiles::Triple:   loop->AddString ( "triple"  ,false );
+                                break;
+      case Smiles::Deloc:    loop->AddString ( "deloc"   ,false );
+    }
+  }
+
+
+  int Smiles::readFromCIF_ccp4 ( mmdb::mmcif::PLoop mmCIFLoop,
+                               int bondNo,
+                               Container<Atom> & atoms )  {
+  int rc;
+
+    rc = 0;
+
+    get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
+                        bondNo,atoms,rc );
+    get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
+                        bondNo,atoms,rc );
+    get_bond_type_from_cif_ccp4 ( bond_order,mmCIFLoop,MMCIF_TAG_TYPE,
+                        bondNo,rc );
+
+    if (mmCIFLoop->GetTagNo(MMCIF_TAG_VALUE_DIST)>=0)  {
+      mmCIFLoop->CopyReal ( bond_length    ,MMCIF_TAG_VALUE_DIST    ,
+                            bondNo,rc );
+      mmCIFLoop->CopyReal ( bond_length_esd,MMCIF_TAG_VALUE_DIST_ESD,
+                            bondNo,rc );
+    } else  {
+      bond_length     = 0.0;
+      bond_length_esd = 0.0;
+    }
+
+    return rc;
+
+  }
+
+
+  int Smiles::readFromCIF_rcsb ( mmdb::mmcif::PLoop mmCIFLoop,
+                               int bondNo,
+                               Container<Atom> & atoms )  {
+  mmdb::pstr p;
+  int        rc;
+
+    rc = 0;
+
+    get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
+                        bondNo,atoms,rc );
+    get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
+                        bondNo,atoms,rc );
+    get_bond_type_from_cif_rcsb ( bond_order,mmCIFLoop,
+                        MMCIF_TAG_VALUE_ORDER,bondNo,rc );
+
+    if ((bond_order==Smiles::Single) ||
+        (bond_order==Smiles::Double))  {
+      p = mmCIFLoop->GetString ( MMCIF_TAG_PDBX_AROMATIC_FLAG,bondNo,rc );
+      if (p)  {
+        if (p[0]=='Y')
+          bond_order = Smiles::Aromatic;
+      }
+    }
+
+    bond_length     = 0.0;
+    bond_length_esd = 0.0;
+
+    return rc;
+
+  }
+
+  int Smiles::readFromCIF ( mmdb::mmcif::PStruct mmCIFStruct,
+                                 Container<Atom> & atoms ) {
+  mmdb::pstr p;
+  int        rc;
+
+    rc = 0;
+
+    get_atom_from_cif ( atom_1,mmCIFStruct,MMCIF_TAG_ATOM_ID_1,
+                        atoms,rc );
+    get_atom_from_cif ( atom_2,mmCIFStruct,MMCIF_TAG_ATOM_ID_2,
+                        atoms,rc );
+    get_bond_type_from_cif ( bond_order,mmCIFStruct,
+                        MMCIF_TAG_VALUE_ORDER,rc );
+
+    if ((bond_order==Smiles::Single) ||
+        (bond_order==Smiles::Double))  {
+      p = mmCIFStruct->GetString ( MMCIF_TAG_PDBX_AROMATIC_FLAG,rc );
+      if (p)  {
+        if (p[0]=='Y')
+          bond_order = Smiles::Aromatic;
+      }
+    }
+
+    bond_length     = 0.0;
+    bond_length_esd = 0.0;
+
+    return rc;
+
+  }
+
+  bool Smiles::compare ( Container<Atom> & atoms, PBond bond,
+                       Container<Atom> & bond_atoms )  {
+  mmdb::AtomName a11,a12, a21,a22;
+
+    strcpy ( a11,atoms.at(atom_1)->id() );
+    strcpy ( a12,atoms.at(atom_2)->id() );
+
+    strcpy ( a21,bond_atoms.at(bond->atom1())->id() );
+    strcpy ( a22,bond_atoms.at(bond->atom2())->id() );
+
+    if (!strcmp(a11,a21))
+      return (strcmp(a12,a22)==0);
+    else if (!strcmp(a11,a22))
+      return (strcmp(a12,a21)==0);
+
+    return false;
+
+  }
+
+  bool Smiles::copy ( Container<Atom> & atoms,
+                         PBond bond,
+                         Container<Atom> & bond_atoms )  {
+  mmdb::AtomName a1,a2;
+  int      i;
+
+    strcpy ( a1,bond_atoms.at(bond->atom1())->id() );
+    strcpy ( a2,bond_atoms.at(bond->atom2())->id() );
+
+    atom_1 = -1;
+    atom_2 = -1;
+
+    for (i=0;(i<atoms.numberOf());i++)  {
+      if (!strcmp(atoms.at(i)->id(),a1))  atom_1 = i;
+      if (!strcmp(atoms.at(i)->id(),a2))  atom_2 = i;
+    }
+
+    if ((atom_1>=0) && (atom_2>=0))  {
+      bond_order      = bond->order ();
+      bond_length     = bond->length();
+      bond_length_esd = bond->length_esd();
+      return true;
+    }
+
+    return false;
+
+  }
+
+  void Smiles::copy ( PBond bond, mmdb::ivector anmatch )  {
+    if (anmatch)  {
+      atom_1 = anmatch[bond->atom1()];
+      atom_2 = anmatch[bond->atom2()];
+    } else  {
+      atom_1 = bond->atom1();
+      atom_2 = bond->atom2();
+    }
+    bond_order      = bond->order     ();
+    bond_length     = bond->length    ();
+    bond_length_esd = bond->length_esd();
+  }
+
+
+  void Smiles::makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop )  {
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID        );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_1      );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_2      );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_TYPE           );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_DIST     );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_DIST_ESD );
+  }
+
+  void Smiles::writeToCIF ( mmdb::mmcif::PLoop mmCIFLoop,
+                              mmdb::cpstr monID,
+                              Container<Atom> & atoms )  {
+    mmCIFLoop->AddString ( monID,false              );
+    add_atom_to_cif      ( mmCIFLoop,atom_1,atoms   );
+    add_atom_to_cif      ( mmCIFLoop,atom_2,atoms   );
+    add_bond_type_to_cif ( mmCIFLoop,bond_order     );
+    mmCIFLoop->AddReal   ( bond_length    ,"%10.3f" );
+    mmCIFLoop->AddReal   ( bond_length_esd,"%10.3f" );
+  }
+
+*/
+
+}  // namespace ccp4srs
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_smiles.h ccp4srs/ccp4srs/ccp4srs_smiles.h
--- ccp4srs-old/ccp4srs/ccp4srs_smiles.h	1969-12-31 16:00:00.000000000 -0800
+++ ccp4srs/ccp4srs/ccp4srs_smiles.h	2014-09-09 21:34:12.000000000 -0700
@@ -0,0 +1,104 @@
+//  $Id: ccp4srs_smiles.h $
+//  =================================================================
+//
+//   CCP4 SRS Library: Storage, Retrieval and Search support for
+//   CCP4 ligand data.
+//
+//   Copyright (C) Eugene Krissinel 2010-2013.
+//
+//   This library is free software: you can redistribute it and/or
+//   modify it under the terms of the GNU Lesser General Public
+//   License version 3, modified in accordance with the provisions
+//   of the license to address the requirements of UK law.
+//
+//   You should have received a copy of the modified GNU Lesser
+//   General Public License along with this library. If not, copies
+//   may be downloaded from http://www.ccp4.ac.uk/ccp4license.php
+//
+//   This program is distributed in the hope that it will be useful,
+//   but WITHOUT ANY WARRANTY; without even the implied warranty of
+//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//   GNU Lesser General Public License for more details.
+//
+//  =================================================================
+//
+//    12.04.14   <--  Date of Last Modification.
+//                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+//  -----------------------------------------------------------------
+//
+//  **** Module  :  ccp4srs_smiles  <interface>
+//       ~~~~~~~~~
+//  **** Classes :  ccp4srs::Smiles  - atom description class
+//       ~~~~~~~~~
+//
+//  (C) E. Krissinel 2010-2014
+//
+//  =================================================================
+//
+
+#ifndef CCP4SRS_SMILES_H
+#define CCP4SRS_SMILES_H
+
+#include "memio_.h"
+
+#include "mmdb2/mmdb_mattype.h"
+#include "mmdb2/mmdb_mmcif_.h"
+
+namespace ccp4srs  {
+
+  DefineClass(Smiles);
+
+  class Smiles  {
+
+    public:
+
+      Smiles();
+      virtual ~Smiles();
+
+      void freeSmiles();
+
+      int  readFromCIF_rcsb ( mmdb::mmcif::PLoop mmCIFLoop,
+                              mmdb::cpstr program );
+
+      bool   isEmpty();
+
+      inline mmdb::cpstr getVersion  ()  { return ver;       }
+      inline mmdb::cpstr getSmiles   ()  { return plain;     }
+      inline mmdb::cpstr getCanonical()  { return canonical; }
+      inline mmdb::cpstr getInChI    ()  { return plain;     }
+      inline mmdb::cpstr getInChIKey ()  { return canonical; }
+
+      void copy ( PSmiles smiles );
+
+/*
+      static void makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop );
+      int  readFromCIF_ccp4 ( mmdb::mmcif::PLoop mmCIFLoop, int bondNo,
+                              Container<Atom> & atoms );
+      int  readFromCIF_rcsb ( mmdb::mmcif::PLoop mmCIFLoop, int bondNo,
+                              Container<Atom> & atoms );
+      int  readFromCIF ( mmdb::mmcif::PStruct mmCIFStruct,
+                         Container<Atom> & atoms );
+      void writeToCIF  ( mmdb::mmcif::PLoop mmCIFLoop, mmdb::cpstr monID,
+                         Container<Atom> & atoms );
+
+      bool compare ( Container<Atom> & atoms, PBond bond,
+                     Container<Atom> & bond_atoms );
+
+      bool copy    ( Container<Atom> & atoms, PBond bond,
+                     Container<Atom> & bond_atoms );
+*/
+
+      void write_mem ( PMemIO memIO, int version );
+      bool read_mem  ( PMemIO memIO, int version,
+                          bool * Ok = NULL );
+
+    protected:
+      mmdb::pstr  ver;       //!< software version
+      mmdb::pstr  plain;     //!< plain smiles
+      mmdb::pstr  canonical; //!< canonical smiles
+
+  };
+
+}  // namespace ccp4srs
+
+#endif // CCP4SRS_SMILES_H
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_torsion.cpp ccp4srs/ccp4srs/ccp4srs_torsion.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_torsion.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_torsion.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_torsion.cpp, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_torsion.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010-2011.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,158 +22,160 @@
 //
 //  =================================================================
 //
-//    18.10.11   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_torsion  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSTorsion  - torsion angle restraint class
+//  **** Classes :  ccp4srs::Torsion  - torsion angle restraint class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010-2011
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
 
-#ifndef __STRING_H
 #include <string.h>
-#endif
 
 #include "ccp4srs_torsion.h"
 #include "ccp4srs_defs.h"
 
-CCP4SRSTorsion::CCP4SRSTorsion()  {
-  torsion_id[0]  = char(0);
-  atom_1         = -1;
-  atom_2         = -1;
-  atom_3         = -1;
-  atom_4         = -1;
-  torsion_period = 0;
-  torsion        = 0.0;
-  torsion_esd    = 0.0;
-}
-
-CCP4SRSTorsion::~CCP4SRSTorsion()  {
-}
-
-
-void CCP4SRSTorsion::makeCIFTags ( PCMMCIFLoop mmCIFLoop )  {
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID         );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ID              );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_1       );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_2       );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_3       );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_4       );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_ANGLE     );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_ANGLE_ESD );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_PERIOD          );
-}
-
-int CCP4SRSTorsion::readFromCIF ( PCMMCIFLoop mmCIFLoop, int torsionNo,
-                            CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-int rc;
-
-  rc = 0;
-
-  mmCIFLoop->CopyString ( torsion_id,sizeof(TorsionID)-1,
-                          MMCIF_TAG_ID,torsionNo,rc );
-
-  get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
-                      torsionNo,atoms,rc );
-  get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
-                      torsionNo,atoms,rc );
-  get_atom_from_cif ( atom_3,mmCIFLoop,MMCIF_TAG_ATOM_ID_3,
-                      torsionNo,atoms,rc );
-  get_atom_from_cif ( atom_4,mmCIFLoop,MMCIF_TAG_ATOM_ID_4,
-                      torsionNo,atoms,rc );
-
-  mmCIFLoop->CopyReal ( torsion,MMCIF_TAG_VALUE_ANGLE,torsionNo,rc );
-  mmCIFLoop->CopyReal ( torsion_esd,MMCIF_TAG_VALUE_ANGLE_ESD,
-                                                      torsionNo,rc );
-
-  mmCIFLoop->CopyInteger(torsion_period,MMCIF_TAG_PERIOD,torsionNo,rc);
-
-  return rc;
-
-}
-
-/*
-loop_
-_chem_comp_tor.comp_id
-_chem_comp_tor.id
-_chem_comp_tor.atom_id_1
-_chem_comp_tor.atom_id_2
-_chem_comp_tor.atom_id_3
-_chem_comp_tor.atom_id_4
-_chem_comp_tor.value_angle
-_chem_comp_tor.value_angle_esd
-_chem_comp_tor.period
- ATP      var_1    O2A    PA     O3A    PB       -59.994   20.000   1
-*/
-
-
-void CCP4SRSTorsion::writeToCIF ( PCMMCIFLoop mmCIFLoop, cpstr monID,
-                             CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-
-  mmCIFLoop->AddString ( monID,False       );
-  mmCIFLoop->AddString ( torsion_id,False  );
-
-  add_atom_to_cif ( mmCIFLoop,atom_1,atoms );
-  add_atom_to_cif ( mmCIFLoop,atom_2,atoms );
-  add_atom_to_cif ( mmCIFLoop,atom_3,atoms );
-  add_atom_to_cif ( mmCIFLoop,atom_4,atoms );
-  mmCIFLoop->AddReal    ( torsion    ,"%10.3f" );
-  mmCIFLoop->AddReal    ( torsion_esd,"%10.3f" );
-  mmCIFLoop->AddInteger ( torsion_period );
-
-}
-
-void  CCP4SRSTorsion::copy ( PCCP4SRSTorsion trs, ivector anmatch )  {
-  strcpy ( torsion_id,trs->id() );
-  if (anmatch)  {
-    atom_1 = anmatch[trs->atom1()];
-    atom_2 = anmatch[trs->atom2()];
-    atom_3 = anmatch[trs->atom3()];
-    atom_4 = anmatch[trs->atom4()];
-  } else  {
-    atom_1 = trs->atom1();
-    atom_2 = trs->atom2();
-    atom_3 = trs->atom3();
-    atom_4 = trs->atom4();
-  }
-  torsion_period = trs->period();
-  torsion        = trs->value ();
-  torsion_esd    = trs->esd   ();
-}
-
-void  CCP4SRSTorsion::write_mem ( PCMemIO memIO, int version )  {
-UNUSED_ARGUMENT(version);
-  memIO->put_line    ( torsion_id     );
-  memIO->put_integer ( atom_1         );
-  memIO->put_integer ( atom_2         );
-  memIO->put_integer ( atom_3         );
-  memIO->put_integer ( atom_4         );
-  memIO->put_ibyte   ( torsion_period );
-  memIO->put_float   ( torsion        );
-  memIO->put_float   ( torsion_esd    );
-}
-
-Boolean CCP4SRSTorsion::read_mem ( PCMemIO memIO, int version,
-                                   Boolean * Ok )  {
-UNUSED_ARGUMENT(version);
-Boolean success;
-  if (Ok)  success = *Ok;
-     else  success = True;
-  memIO->get_line    ( torsion_id    ,&success );
-  memIO->get_integer ( atom_1        ,&success );
-  memIO->get_integer ( atom_2        ,&success );
-  memIO->get_integer ( atom_3        ,&success );
-  memIO->get_integer ( atom_4        ,&success );
-  memIO->get_ibyte   ( torsion_period,&success );
-  memIO->get_float   ( torsion       ,&success );
-  memIO->get_float   ( torsion_esd   ,&success );
-  if (Ok)  *Ok = success;
-  return success;
-}
+namespace ccp4srs  {
 
+  Torsion::Torsion()  {
+    torsion_id[0]  = char(0);
+    atom_1         = -1;
+    atom_2         = -1;
+    atom_3         = -1;
+    atom_4         = -1;
+    torsion_period = 0;
+    torsion        = 0.0;
+    torsion_esd    = 0.0;
+  }
+
+  Torsion::~Torsion()  {
+  }
+
+
+  void Torsion::makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop )  {
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID         );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ID              );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_1       );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_2       );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_3       );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_4       );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_ANGLE     );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_ANGLE_ESD );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_PERIOD          );
+  }
+
+  int Torsion::readFromCIF ( mmdb::mmcif::PLoop mmCIFLoop,
+                             int torsionNo, Container<Atom> & atoms ) {
+  int rc;
+
+    rc = 0;
+
+    mmCIFLoop->CopyString ( torsion_id,sizeof(TorsionID)-1,
+                            MMCIF_TAG_ID,torsionNo,rc );
+
+    get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
+                        torsionNo,atoms,rc );
+    get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
+                        torsionNo,atoms,rc );
+    get_atom_from_cif ( atom_3,mmCIFLoop,MMCIF_TAG_ATOM_ID_3,
+                        torsionNo,atoms,rc );
+    get_atom_from_cif ( atom_4,mmCIFLoop,MMCIF_TAG_ATOM_ID_4,
+                        torsionNo,atoms,rc );
+
+    mmCIFLoop->CopyReal ( torsion,MMCIF_TAG_VALUE_ANGLE,torsionNo,rc );
+    mmCIFLoop->CopyReal ( torsion_esd,MMCIF_TAG_VALUE_ANGLE_ESD,
+                                                        torsionNo,rc );
+
+    mmCIFLoop->CopyInteger(torsion_period,MMCIF_TAG_PERIOD,torsionNo,rc);
+
+    return rc;
+
+  }
+
+  /*
+  loop_
+  _chem_comp_tor.comp_id
+  _chem_comp_tor.id
+  _chem_comp_tor.atom_id_1
+  _chem_comp_tor.atom_id_2
+  _chem_comp_tor.atom_id_3
+  _chem_comp_tor.atom_id_4
+  _chem_comp_tor.value_angle
+  _chem_comp_tor.value_angle_esd
+  _chem_comp_tor.period
+   ATP      var_1    O2A    PA     O3A    PB       -59.994   20.000   1
+  */
+
+
+  void Torsion::writeToCIF ( mmdb::mmcif::PLoop mmCIFLoop,
+                             mmdb::cpstr monID,
+                             Container<Atom> & atoms )  {
+
+    mmCIFLoop->AddString ( monID,false       );
+    mmCIFLoop->AddString ( torsion_id,false  );
+
+    add_atom_to_cif ( mmCIFLoop,atom_1,atoms );
+    add_atom_to_cif ( mmCIFLoop,atom_2,atoms );
+    add_atom_to_cif ( mmCIFLoop,atom_3,atoms );
+    add_atom_to_cif ( mmCIFLoop,atom_4,atoms );
+    mmCIFLoop->AddReal    ( torsion    ,"%10.3f" );
+    mmCIFLoop->AddReal    ( torsion_esd,"%10.3f" );
+    mmCIFLoop->AddInteger ( torsion_period );
+
+  }
+
+  void  Torsion::copy ( PTorsion trs,
+                               mmdb::ivector anmatch )  {
+    strcpy ( torsion_id,trs->id() );
+    if (anmatch)  {
+      atom_1 = anmatch[trs->atom1()];
+      atom_2 = anmatch[trs->atom2()];
+      atom_3 = anmatch[trs->atom3()];
+      atom_4 = anmatch[trs->atom4()];
+    } else  {
+      atom_1 = trs->atom1();
+      atom_2 = trs->atom2();
+      atom_3 = trs->atom3();
+      atom_4 = trs->atom4();
+    }
+    torsion_period = trs->period();
+    torsion        = trs->value ();
+    torsion_esd    = trs->esd   ();
+  }
+
+  void  Torsion::write_mem ( PMemIO memIO, int version )  {
+  UNUSED_ARGUMENT(version);
+    memIO->put_line    ( torsion_id     );
+    memIO->put_integer ( atom_1         );
+    memIO->put_integer ( atom_2         );
+    memIO->put_integer ( atom_3         );
+    memIO->put_integer ( atom_4         );
+    memIO->put_ibyte   ( torsion_period );
+    memIO->put_float   ( torsion        );
+    memIO->put_float   ( torsion_esd    );
+  }
+
+  bool Torsion::read_mem ( PMemIO memIO, int version, bool * Ok )  {
+  UNUSED_ARGUMENT(version);
+  bool success;
+    if (Ok)  success = *Ok;
+       else  success = true;
+    memIO->get_line    ( torsion_id    ,&success );
+    memIO->get_integer ( atom_1        ,&success );
+    memIO->get_integer ( atom_2        ,&success );
+    memIO->get_integer ( atom_3        ,&success );
+    memIO->get_integer ( atom_4        ,&success );
+    memIO->get_ibyte   ( torsion_period,&success );
+    memIO->get_float   ( torsion       ,&success );
+    memIO->get_float   ( torsion_esd   ,&success );
+    if (Ok)  *Ok = success;
+    return success;
+  }
+
+}  // namespace ccp4srs
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_torsion.h ccp4srs/ccp4srs/ccp4srs_torsion.h
--- ccp4srs-old/ccp4srs/ccp4srs_torsion.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_torsion.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_torsion.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_torsion.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010-2011.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    18.10.11   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_torsion  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSTorsion  - torsion angle restraint class
+//  **** Classes :  ccp4srs::Torsion  - torsion angle restraint class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010-2011
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
@@ -41,46 +41,49 @@
 
 #include "ccp4srs_atom.h"
 
-DefineClass(CCP4SRSTorsion);
+namespace ccp4srs  {
 
-typedef char TorsionID[20];
+  DefineClass(Torsion);
 
-class CCP4SRSTorsion {
+  typedef char TorsionID[20];
 
-  public:
-    CCP4SRSTorsion();
-    virtual ~CCP4SRSTorsion();
-
-    inline cpstr    id    () { return torsion_id;     }
-    inline int      atom1 () { return atom_1;         }
-    inline int      atom2 () { return atom_2;         }
-    inline int      atom3 () { return atom_3;         }
-    inline int      atom4 () { return atom_4;         }
-    inline int      period() { return torsion_period; }
-    inline realtype value () { return torsion;        }
-    inline realtype esd   () { return torsion_esd;    }
-
-    static void makeCIFTags ( PCMMCIFLoop mmCIFLoop );
-    int  readFromCIF ( PCMMCIFLoop mmCIFLoop, int angleNo,
-                       CCP4SRSContainer<CCP4SRSAtom> & atoms );
-    void writeToCIF  ( PCMMCIFLoop mmCIFLoop, cpstr monID,
-                       CCP4SRSContainer<CCP4SRSAtom> & atoms );
-
-    void    write_mem ( PCMemIO memIO, int version );
-    Boolean read_mem  ( PCMemIO memIO, int version,
-                        Boolean * Ok = NULL );
-
-    void copy ( PCCP4SRSTorsion trs, ivector anmatch=NULL );
-
-  protected:
-    TorsionID  torsion_id;     //!< torsion angle id
-    int        atom_1,atom_2;  //!< ordinal numbers of atoms
-    int        atom_3,atom_4;  ///  that form the angle [0,1,...]
-    int        torsion_period; //!< torsion period
-    realtype   torsion;        //!< torsion angle in degrees
-    realtype   torsion_esd;    //!< torsion angle esd in degrees;
-                               /// set to 0.0 if not provided
+  class Torsion {
 
-};
+    public:
+      Torsion();
+      virtual ~Torsion();
+
+      inline mmdb::cpstr    id    () { return torsion_id;     }
+      inline int            atom1 () { return atom_1;         }
+      inline int            atom2 () { return atom_2;         }
+      inline int            atom3 () { return atom_3;         }
+      inline int            atom4 () { return atom_4;         }
+      inline int            period() { return torsion_period; }
+      inline mmdb::realtype value () { return torsion;        }
+      inline mmdb::realtype esd   () { return torsion_esd;    }
+
+      static void makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop );
+      int  readFromCIF ( mmdb::mmcif::PLoop mmCIFLoop, int angleNo,
+                         Container<Atom> & atoms );
+      void writeToCIF  ( mmdb::mmcif::PLoop mmCIFLoop, mmdb::cpstr monID,
+                         Container<Atom> & atoms );
+
+      void write_mem ( PMemIO memIO, int version );
+      bool read_mem  ( PMemIO memIO, int version, bool * Ok = NULL );
+
+      void copy ( PTorsion trs, mmdb::ivector anmatch=NULL );
+
+    protected:
+      TorsionID   torsion_id;     //!< torsion angle id
+      int         atom_1,atom_2;  //!< ordinal numbers of atoms
+      int         atom_3,atom_4;  ///  that form the angle [0,1,...]
+      int         torsion_period; //!< torsion period
+      mmdb::realtype torsion;     //!< torsion angle in degrees
+      mmdb::realtype torsion_esd; //!< torsion angle esd in degrees;
+                                  /// set to 0.0 if not provided
+
+  };
+
+}  // namespace ccp4srs
 
 #endif // CCP4SRS_TORSION_H
